--
-- Bale Wrapper Extension
--
-- # Author:  	Boris555
-- # date: 		10.04.2021
--

------------------------------------------------------------------
Wrapper = {};
Wrapper.homeDir = g_currentModDirectory
Wrapper.conversionAlfalfaFillType = nil
Wrapper.conversionCloverFillType = nil
					

function Wrapper.prerequisitesPresent(specializations)
    return true
end;


function Wrapper:onLoad(savegame)
	local fillTypes = {['CLOVER_WINDROW'] = 'CLOVER_FERMENTED',['ALFALFA_WINDROW']= 'ALFALFA_FERMENTED'}
	local fillTypeIndexIN
	local fillTypeIndexOUT
	local bale
	
	if self.spec_baleWrapper ~= nil then
		if self.spec_baleWrapper.roundBaleWrapper ~= nil and self.spec_baleWrapper.squareBaleWrapper ~= nil then
			local roundWrapper = self.spec_baleWrapper.roundBaleWrapper
			local squareWrapper = self.spec_baleWrapper.squareBaleWrapper
		
			for fillTypeIN,fillTypeOUT in pairs(fillTypes) do
				
				if fillTypeIN == nil or g_fillTypeManager:getFillTypeByName(fillTypeIN) == nil then
					print( "Warning: invalid fillType (windrow) '%s' for '%s' given!", tostring(fillTypeIN), key)
					break
				end
				if fillTypeOUT == nil or g_fillTypeManager:getFillTypeByName(fillTypeOUT) == nil then
					print( "Warning: invalid fillType (fermented) '%s' for '%s' given!", tostring(fillTypeOUT), key)
					break
				end
				
				fillTypeIndexIN = g_fillTypeManager:getFillTypeIndexByName(fillTypeIN)
				fillTypeIndexOUT = g_fillTypeManager:getFillTypeIndexByName(fillTypeOUT)
				--round bales
				if roundWrapper.allowedBaleTypes ~= nil then
					bale = g_baleTypeManager:getBale(fillTypeIndexOUT, true, 1.12, 0.9, 2.4, 1.3)
					roundWrapper.allowedBaleTypes[fillTypeIndexIN] = {}
					table.insert(roundWrapper.allowedBaleTypes[fillTypeIndexIN], {fillType=fillTypeIndexIN,wrapperBaleFilename=bale["filename"], minBaleDiameter=1.1, maxBaleDiameter=1.3, minBaleWidth=1.1, maxBaleWidth=1.3})
				else
					print( "Warning: no round bale defined for fill type'%s'", tostring(fillType)) 
				end
				--square bales
				if squareWrapper.allowedBaleTypes ~= nil then
					bale = g_baleTypeManager:getBale(fillTypeIndexOUT, false, 1.20, 0.9, 2.4, 1.3)
					squareWrapper.allowedBaleTypes[fillTypeIndexIN] = {}
					table.insert(squareWrapper.allowedBaleTypes[fillTypeIndexIN], {fillType=fillTypeIndexIN,wrapperBaleFilename=bale["filename"], minBaleWidth=1.15, maxBaleWidth=1.25, minBaleHeight=0.75, maxBaleHeight=0.85, minBaleLength=2.35, maxBaleLength=2.45})	
				else
					print( "Warning: no square bale defined for fill type'%s'", tostring(fillType)) 
				end
			end	
		end
	end
end;

BaleWrapper.onLoad  = Utils.appendedFunction(BaleWrapper.onLoad, Wrapper.onLoad);